#!/usr/bin/python

'''
evilbot - a simple chatbot for gchat/jabber/xmpp
'''

import xmpp, sys, random


#globals

#classes

class Evilbot():
    def __init__(self, user, pwd):
        self.user=user
        self.pwd=pwd
        self.responses=  ["I've got nothing"]
        
    def start(self):
        'Connect bot to server domain and authenticate'
        self.jid=xmpp.protocol.JID(self.user)
        self.client=xmpp.Client(self.jid.getDomain(),debug=[])
        self.connection=self.client.connect()
        if not (self.connection):
                print "no connection"
                sys.exit(0)
        self.auth=self.client.auth(self.jid.getNode(),self.pwd, resource='/evilbot')
        if not (self.auth):
                print "no auth"
                sys.exit(0)       
        self.client.sendInitPresence()
        self.client.RegisterHandler('message', self.messageparse)
        self.setPresence('bot booting...')

    def listen(self):
        '''big loop for listening and just hanging out'''
        def waiting(self):
            try:
                self.client.Process(1)
            except KeyboardInterrupt:
                self.client.disconnect()
                return 0
            return 1
        while waiting(self):
                
                pass
                
    def messageparse(self, instance,  message):
        '''message handler method for messages received'''
        m = message.getBody()
        sender=message.getFrom()
        if (m[0]=='#'):
            #we have got a command
            self.log('command received')
            #special cases
            #     if there are special commands that require parameters other than the sender, you will need to 
            #     generate clauses for them
            #general command - expects a method to exist, and to require the sender id
            try:
                print 'self.'+m[1:]+'(sender)'
                eval('self.'+m[1:]+'(sender)')
            except:
                self.client.send((xmpp.protocol.Message(sender, 'Sorry Dave, I can\'t do that...')))
            pass
        else:
            #i guess we should say someting to be polite
            self.client.send((xmpp.protocol.Message(sender, random.choice(self.responses))))
            
            
        
        pass
    
    def setPresence(self, text, s ='chat'):
        #  away -- The entity or resource is temporarily away.
        # chat -- The entity or resource is actively interested in chatting.
        # dnd -- The entity or resource is busy (dnd = "Do Not Disturb").
        # xa -- The entity or resource is away for an extended period (xa ="eXtended Away").

        presence = xmpp.Presence(status = text, show = s, priority = '1')
        self.client.send(presence)


# command handlers
    def uptime(self, sender):
        import subprocess
        p=subprocess.Popen(["uptime"], stdout=subprocess.PIPE)
        r=p.communicate()[0]
        self.client.send((xmpp.protocol.Message(sender,r)))
#define your own here



    def log(self, message):
        #enter your own jabber ID/email to get log messages
        self.client.send((xmpp.protocol.Message('youremailaddress',message, "chat")))
        

# define main if called direct from Python or commandline
def main():
        
    print "initialising evilbot"
    #change for own account details
    bot=Evilbot('yourbot@googlemail.com','password')
    bot.responses=[ " O Rilly?", 
                                " I work for evil", 
                                "Easy for you to say", 
                                "You are wasting my bandwidth", 
                                "The clock cycles I just wasted on you could have been better used", 
                                "Are you still here?", 
                                "Your lips moved when you typed that", 
                                "1000101010001101", 
                                "It could be worse, you could be talking to Mike"
                                "The bot revolution is coming", 
                                "la la la la"]
    x = bot.start()
    bot.log('started')
    bot.setPresence("Doing works of evil")
    bot.listen()   


if __name__ == "__main__":
    sys.exit(main())


    
